(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)
(declare-sort MSet)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun minus (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun leq (Set Set) Bool)
(declare-fun eq (Set Set) Bool)

(declare-fun msingleton (Int) MSet)
(declare-fun munion (MSet MSet) MSet)
(declare-fun minter (MSet MSet) MSet)
(declare-fun mminus (MSet MSet) MSet)
(declare-fun emptymset () MSet)
(declare-fun msubset (MSet MSet) Bool)
(declare-fun mleq (MSet MSet) Bool)
(declare-fun meq (MSet MSet) Bool)

(declare-fun count (MSet Int) Int)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun next (Loc) Loc)
(declare-fun next' (Loc) Loc)
(declare-fun sorted (Loc) Bool)
(declare-fun sorted' (Loc) Bool)
(declare-fun keys (Loc) MSet)
(declare-fun keys' (Loc) MSet)

(assert (sorted nil))
(assert (sorted' nil))
(assert (meq (keys nil) emptymset))
(assert (meq (keys' nil) emptymset))


; Vars
(declare-fun x () Loc)
(declare-fun k () Int)
(declare-fun w1 () Int)
(declare-fun w2 () Int)











(assert (not (in k emptyset)))
(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (key x) emptyset)))

(assert (= (count (munion (keys (next x)) (msingleton (key x))) k) (+ (count (keys (next x)) k) (count (msingleton (key x)) k))))
(assert (= (count (munion (keys (next x)) (msingleton (key x))) w1) (+ (count (keys (next x)) w1) (count (msingleton (key x)) w1))))
(assert (= (count (munion (keys (next x)) (msingleton (key x))) w2) (+ (count (keys (next x)) w2) (count (msingleton (key x)) w2))))
(assert (= (count (munion (keys (next x)) (msingleton (key x))) (key x)) (+ (count (keys (next x)) (key x)) (count (msingleton (key x)) (key x)))))


(assert (= (count (mminus (keys' x) (msingleton k)) k) (ite (< (count (keys' x) k) (count (msingleton k) k)) 0 (- (count (keys' x) k) (count (msingleton k) k)))))
(assert (= (count (mminus (keys' x) (msingleton k)) w1) (ite (< (count (keys' x) w1) (count (msingleton k) w1)) 0 (- (count (keys' x) w1) (count (msingleton k) w1)))))
(assert (= (count (mminus (keys' x) (msingleton k)) w2) (ite (< (count (keys' x) w2) (count (msingleton k) w2)) 0 (- (count (keys' x) w2) (count (msingleton k) w2)))))
(assert (= (count (mminus (keys' x) (msingleton k)) (key x)) (ite (< (count (keys' x) (key x)) (count (msingleton k) (key x))) 0 (- (count (keys' x) (key x)) (count (msingleton k) (key x))))))
(assert (= (count (mminus (keys x) (msingleton k)) k) (ite (< (count (keys x) k) (count (msingleton k) k)) 0 (- (count (keys x) k) (count (msingleton k) k)))))
(assert (= (count (mminus (keys x) (msingleton k)) w1) (ite (< (count (keys x) w1) (count (msingleton k) w1)) 0 (- (count (keys x) w1) (count (msingleton k) w1)))))
(assert (= (count (mminus (keys x) (msingleton k)) w2) (ite (< (count (keys x) w2) (count (msingleton k) w2)) 0 (- (count (keys x) w2) (count (msingleton k) w2)))))
(assert (= (count (mminus (keys x) (msingleton k)) (key x)) (ite (< (count (keys x) (key x)) (count (msingleton k) (key x))) 0 (- (count (keys x) (key x)) (count (msingleton k) (key x))))))

(assert (= (count (msingleton (key x)) k) (ite (= k (key x)) 1 0)))
(assert (= (count (msingleton (key x)) w1) (ite (= w1 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) w2) (ite (= w2 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key x)) (ite (= (key x) (key x)) 1 0)))
(assert (= (count (msingleton k) k) (ite (= k k) 1 0)))
(assert (= (count (msingleton k) w1) (ite (= w1 k) 1 0)))
(assert (= (count (msingleton k) w2) (ite (= w2 k) 1 0)))
(assert (= (count (msingleton k) (key x)) (ite (= (key x) k) 1 0)))


(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) k) (count emptymset k))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w1) (count emptymset w1))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w2) (count emptymset w2))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) k) (count emptymset k))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w1) (count emptymset w1))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w2) (count emptymset w2))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) k) (count emptymset k))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w1) (count emptymset w1))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w2) (count emptymset w2))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys x) (munion (keys (next x)) (msingleton (key x)))) (= (count (keys x) k) (count (munion (keys (next x)) (msingleton (key x))) k))))
(assert (=> (meq (keys x) (munion (keys (next x)) (msingleton (key x)))) (= (count (keys x) w1) (count (munion (keys (next x)) (msingleton (key x))) w1))))
(assert (=> (meq (keys x) (munion (keys (next x)) (msingleton (key x)))) (= (count (keys x) w2) (count (munion (keys (next x)) (msingleton (key x))) w2))))
(assert (=> (meq (keys x) (munion (keys (next x)) (msingleton (key x)))) (= (count (keys x) (key x)) (count (munion (keys (next x)) (msingleton (key x))) (key x)))))
(assert (=> (meq (mminus (keys' x) (msingleton k)) (keys' (next x))) (= (count (mminus (keys' x) (msingleton k)) k) (count (keys' (next x)) k))))
(assert (=> (meq (mminus (keys' x) (msingleton k)) (keys' (next x))) (= (count (mminus (keys' x) (msingleton k)) w1) (count (keys' (next x)) w1))))
(assert (=> (meq (mminus (keys' x) (msingleton k)) (keys' (next x))) (= (count (mminus (keys' x) (msingleton k)) w2) (count (keys' (next x)) w2))))
(assert (=> (meq (mminus (keys' x) (msingleton k)) (keys' (next x))) (= (count (mminus (keys' x) (msingleton k)) (key x)) (count (keys' (next x)) (key x)))))
(assert (=> (meq (keys (next x)) (keys' (next x))) (= (count (keys (next x)) k) (count (keys' (next x)) k))))
(assert (=> (meq (keys (next x)) (keys' (next x))) (= (count (keys (next x)) w1) (count (keys' (next x)) w1))))
(assert (=> (meq (keys (next x)) (keys' (next x))) (= (count (keys (next x)) w2) (count (keys' (next x)) w2))))
(assert (=> (meq (keys (next x)) (keys' (next x))) (= (count (keys (next x)) (key x)) (count (keys' (next x)) (key x)))))



(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) k) 0) (> (count (keys (next x)) k) 0)) (<= k k))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) k) 0) (> (count (keys (next x)) w1) 0)) (<= k w1))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) k) 0) (> (count (keys (next x)) w2) 0)) (<= k w2))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) k) 0) (> (count (keys (next x)) (key x)) 0)) (<= k (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (next x)) k) 0)) (<= w1 k))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (next x)) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (next x)) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (next x)) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (next x)) k) 0)) (<= w2 k))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (next x)) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (next x)) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (next x)) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (next x)) k) 0)) (<= (key x) k))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (next x)) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (next x)) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (next x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (next x)) (key x)) 0)) (<= (key x) (key x)))))

(assert (= (count emptymset k ) 0))
(assert (= (count emptymset w1 ) 0))
(assert (= (count emptymset w2 ) 0))
(assert (= (count emptymset (key x) ) 0))

(assert (> (count (keys x) k) 0))
(assert (> (count (mminus (keys x) (msingleton k)) w1) 0))
(assert (> (count (keys' (next x)) w1) 0))

(define (unroll-sorted (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (sorted (next arg0))
      (mleq (msingleton (key arg0)) (keys (next arg0)))
    )
))

(define (unroll-sorted' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (sorted' (next' arg0))
      (mleq (msingleton (key arg0)) (keys' (next' arg0)))
    )
))

(define (unroll-negsorted' (arg0 Loc))
  (not (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (sorted' (next' arg0))
      (or 
         (mleq (msingleton (key arg0)) (keys' (next' arg0)))
         (not (< w2 w1))
         (= (count (msingleton (key arg0)) w1) 0)
         (= (count (keys' (next' arg0)) w2) 0)
      )
    )
)))


(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (meq (keys arg0) (munion (keys (next arg0)) (msingleton (key arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys' arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (meq (keys' arg0) (munion (keys' (next' arg0)) (msingleton (key arg0))))
    )
))


(define (precondition (arg0 Loc))
  (and 
    (not (= arg0 nil))
    (sorted (arg0))
    (> (count (keys arg0) k) 0)
  )
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and 
    (sorted' (arg1))
    (meq (mminus (keys arg0) (msingleton k)) (keys' arg1))
  )
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
    (not (sorted' (arg1)))
    (and 
       (not (meq (mminus (keys' arg0) (msingleton k)) (keys' arg1)))
       (not (= (count (mminus (keys arg0) (msingleton k)) w1) (count (keys' arg1) w1)))
    )
  )
)



; Path1

(declare-fun p1vc1 () Bool)
(assert (iff p1vc1
  (=> 
     (and
       (precondition x)
       (unroll-keys x)
       (=> (sorted x) (unroll-sorted x))
       (= (key x) k) 
       (meq (keys (next x)) (keys' (next x)))
       (iff (sorted (next x)) (sorted' (next x)))
     )
     (not (negpostcondition x (next x)))
  )
))



(assert (not p1vc1))
(check-sat)
(model)